#![feature(future_join)]

extern crate async_std;
extern crate juno_build;
extern crate hercules_rt;

juno_build::juno!("matmul");

fn main() {
    async_std::task::block_on(async {
        let mut a = vec![1.0, 2.0, 3.0, 4.0];
        let mut b = vec![5.0, 6.0, 7.0, 8.0];
        let mut c = vec![0.0, 0.0, 0.0, 0.0];
        unsafe {
            matmul(a.as_mut_ptr(), b.as_mut_ptr(), c.as_mut_ptr(), 2, 2, 2).await;
        }
        println!("[[{}, {}], [{}, {}]]", c[0], c[1], c[2], c[3]);
        assert_eq!(c[0], 19.0);
        assert_eq!(c[1], 22.0);
        assert_eq!(c[2], 43.0);
        assert_eq!(c[3], 50.0);
    });
}

#[test]
fn matmul_test() {
    main();
}
